Index: src/Formula.cpp
===================================================================
--- src/Formula.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Formula.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,443 @@
+/*
+ * Formula.cpp
+ *
+ *  Created on: Jul 21, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Formula.hpp"
+
+#include <sstream>
+
+#include "World.hpp"
+#include "periodentafel.hpp"
+#include "element.hpp"
+#include "Helpers/Assert.hpp"
+#include "Helpers/Range.hpp"
+
+using namespace std;
+
+Formula::Formula() :
+  numElements(0)
+{}
+
+Formula::Formula(const Formula &src) :
+  elementCounts(src.elementCounts),
+  numElements(src.numElements)
+{}
+
+Formula::Formula(const string &formula) :
+  numElements(0)
+{
+  fromString(formula);
+}
+
+Formula::~Formula()
+{}
+
+Formula &Formula::operator=(const Formula &rhs){
+  // No self-assignment check needed
+  elementCounts=rhs.elementCounts;
+  numElements=rhs.numElements;
+  return *this;
+}
+
+std::string Formula::toString() const{
+  stringstream sstr;
+  for(const_iterator iter=end();iter!=begin();){
+    --iter;
+    sstr << (*iter).first->getSymbol();
+    if((*iter).second>1)
+      sstr << (*iter).second;
+  }
+  return sstr.str();
+}
+
+void Formula::fromString(const std::string &formula) throw(ParseError){
+  // make this transactional, in case an error is thrown
+  Formula res;
+  string::const_iterator begin = formula.begin();
+  string::const_iterator end = formula.end();
+  res.parseFromString(begin,end,static_cast<char>(0));
+  (*this)=res;
+}
+
+int Formula::parseMaybeNumber(string::const_iterator &it,string::const_iterator &end) throw(ParseError){
+  static const range<char> Numbers = makeRange('0',static_cast<char>('9'+1));
+  int count = 0;
+  while(it!=end && Numbers.isInRange(*it))
+    count = (count*10) + ((*it++)-Numbers.first);
+  // one is implicit
+  count = (count!=0)?count:1;
+  return count;
+}
+
+void Formula::parseFromString(string::const_iterator &it,string::const_iterator &end,char delimiter) throw(ParseError){
+  // some constants needed for parsing... Assumes ASCII, change if other encodings are used
+  static const range<char> CapitalLetters = makeRange('A',static_cast<char>('Z'+1));
+  static const range<char> SmallLetters = makeRange('a',static_cast<char>('z'+1));
+  map<char,char> delimiters;
+  delimiters['('] = ')';
+  delimiters['['] = ']';
+  // clean the formula
+  clear();
+  for(/*send from above*/;it!=end && *it!=delimiter;/*updated in loop*/){
+    // we might have a sub formula
+    if(delimiters.count(*it)){
+      Formula sub;
+      char nextdelim=delimiters[*it];
+      sub.parseFromString(++it,end,nextdelim);
+      if(!sub.getElementCount()){
+        throw(ParseError(__FILE__,__LINE__));
+      }
+      int count = parseMaybeNumber(++it,end);
+      addFormula(sub,count);
+      continue;
+    }
+    string shorthand;
+    // Atom names start with a capital letter
+    if(!CapitalLetters.isInRange(*it))
+      throw(ParseError(__FILE__,__LINE__));
+    shorthand+=(*it++);
+    // the rest of the name follows
+    while(it!=end && SmallLetters.isInRange(*it))
+      shorthand+=(*it++);
+    int count = parseMaybeNumber(it,end);
+    // test if the shorthand exists
+    if(!World::getInstance().getPeriode()->FindElement(shorthand))
+      throw(ParseError(__FILE__,__LINE__));
+    // done, we can get the next one
+    addElements(shorthand,count);
+  }
+  if(it==end && delimiter!=0){
+    throw(ParseError(__FILE__,__LINE__));
+  }
+}
+
+bool Formula::checkOut(ostream *output) const{
+  bool result = true;
+  int No = 1;
+
+  if (output != NULL) {
+    *output << "# Ion type data (PP = PseudoPotential, Z = atomic number)" << endl;
+    *output << "#Ion_TypeNr.\tAmount\tZ\tRGauss\tL_Max(PP)L_Loc(PP)IonMass\t# chemical name, symbol" << endl;
+    for(const_iterator iter=begin(); iter!=end();++iter){
+      result = result && (*iter).first->Checkout(output, No++, (*iter).second);
+    }
+    return result;
+  } else
+    return false;
+}
+
+unsigned int Formula::getElementCount() const{
+  return numElements;
+}
+
+bool Formula::hasElement(const element *element) const{
+  ASSERT(element,"Invalid pointer in Formula::hasElement(element*)");
+  return hasElement(element->getNumber());
+}
+
+bool Formula::hasElement(atomicNumber_t Z) const{
+  ASSERT(Z>0,"Invalid atomic Number");
+  ASSERT(World::getInstance().getPeriode()->FindElement(Z),"No Element with this number in Periodentafel");
+  return elementCounts.size()>=Z && elementCounts[Z-1];
+}
+
+bool Formula::hasElement(const string &shorthand) const{
+  const element * element = World::getInstance().getPeriode()->FindElement(shorthand);
+  return hasElement(element);
+}
+
+void Formula::operator+=(const element *element){
+  ASSERT(element,"Invalid pointer in increment of Formula");
+  operator+=(element->getNumber());
+}
+
+void Formula::operator+=(atomicNumber_t Z){
+  ASSERT(Z>0,"Invalid atomic Number");
+  ASSERT(World::getInstance().getPeriode()->FindElement(Z),"No Element with this number in Periodentafel");
+  elementCounts.resize(max<atomicNumber_t>(Z,elementCounts.size()),0); // No-op when we already have the right size
+  // might need to update number of elements
+  if(!elementCounts[Z-1]){
+    numElements++;
+  }
+  elementCounts[Z-1]++;    // atomic numbers start at 1
+}
+
+void Formula::operator+=(const string &shorthand){
+  const element * element = World::getInstance().getPeriode()->FindElement(shorthand);
+  operator+=(element);
+}
+
+void Formula::operator-=(const element *element){
+  ASSERT(element,"Invalid pointer in decrement of Formula");
+  operator-=(element->getNumber());
+}
+
+void Formula::operator-=(atomicNumber_t Z){
+  ASSERT(Z>0,"Invalid atomic Number");
+  ASSERT(World::getInstance().getPeriode()->FindElement(Z),"No Element with this number in Periodentafel");
+  ASSERT(elementCounts.size()>=Z && elementCounts[Z-1], "Element not in Formula upon decrement");
+  elementCounts[Z-1]--;    // atomic numbers start at 1
+  // might need to update number of elements
+  if(!elementCounts[Z-1]){
+    numElements--;
+    // resize the Array if this was at the last position
+    if(Z==elementCounts.size()){
+      // find the first element from the back that is not equal to zero
+      set_t::reverse_iterator riter = find_if(elementCounts.rbegin(),
+                                              elementCounts.rend(),
+                                              bind1st(not_equal_to<mapped_type>(),0));
+      // see how many elements are in this range
+      set_t::reverse_iterator::difference_type diff = riter - elementCounts.rbegin();
+      elementCounts.resize(elementCounts.size()-diff);
+    }
+  }
+}
+
+void Formula::operator-=(const string &shorthand){
+  const element * element = World::getInstance().getPeriode()->FindElement(shorthand);
+  operator-=(element);
+}
+
+void Formula::addElements(const element *element,unsigned int count){
+  ASSERT(element,"Invalid pointer in Formula::addElements(element*)");
+  addElements(element->getNumber(),count);
+}
+
+void Formula::addElements(atomicNumber_t Z,unsigned int count){
+  if(count==0) return;
+  ASSERT(Z>0,"Invalid atomic Number");
+  ASSERT(World::getInstance().getPeriode()->FindElement(Z),"No Element with this number in Periodentafel");
+  elementCounts.resize(max<atomicNumber_t>(Z,elementCounts.size()),0); // No-op when we already have the right size
+  // might need to update number of elements
+  if(!elementCounts[Z-1]){
+    numElements++;
+  }
+  elementCounts[Z-1]+=count;
+}
+
+void Formula::addElements(const string &shorthand,unsigned int count){
+  const element * element = World::getInstance().getPeriode()->FindElement(shorthand);
+  addElements(element,count);
+}
+
+void Formula::addFormula(const Formula &formula,unsigned int n){
+  for(Formula::const_iterator iter=formula.begin();iter!=formula.end();++iter){
+    this->addElements(iter->first,iter->second*n);
+  }
+}
+
+enumeration<Formula::key_type> Formula::enumerateElements() const{
+  enumeration<key_type> res(1);
+  for(Formula::const_iterator iter=begin();iter!=end();++iter){
+    res.add(iter->first);
+  }
+  return res;
+}
+
+const unsigned int Formula::operator[](const element *element) const{
+  ASSERT(element,"Invalid pointer in access of Formula");
+  return operator[](element->getNumber());
+}
+
+const unsigned int Formula::operator[](atomicNumber_t Z) const{
+  ASSERT(Z>0,"Invalid atomic Number");
+  ASSERT(World::getInstance().getPeriode()->FindElement(Z),"No Element with this number in Periodentafel");
+  if(elementCounts.size()<Z)
+    return 0;
+  return elementCounts[Z-1]; // atomic numbers start at 1
+}
+
+const unsigned int Formula::operator[](string shorthand) const{
+  const element * element = World::getInstance().getPeriode()->FindElement(shorthand);
+  return operator[](element);
+}
+
+bool Formula::operator==(const Formula &rhs) const{
+  // quick check... number of elements used
+  if(numElements != rhs.numElements){
+    return false;
+  }
+  // second quick check, size of vectors (== last element in formula)
+  if(elementCounts.size()!=rhs.elementCounts.size()){
+    return false;
+  }
+  // slow check: all elements
+  // direct access to internal structure means all element-counts have to be compared
+  // this avoids access to periodentafel to find elements though and is probably faster
+  // in total
+  return equal(elementCounts.begin(),
+               elementCounts.end(),
+               rhs.elementCounts.begin());
+}
+
+bool Formula::operator!=(const Formula &rhs) const{
+  return !operator==(rhs);
+}
+
+Formula::iterator Formula::begin(){
+  return iterator(elementCounts,0);
+}
+Formula::const_iterator Formula::begin() const{
+  // this is the only place where this is needed, so this is better than making it mutable
+  return const_iterator(const_cast<set_t&>(elementCounts),0);
+}
+Formula::iterator Formula::end(){
+  return iterator(elementCounts);
+}
+Formula::const_iterator Formula::end() const{
+  // this is the only place where this is needed, so this is better than making it mutable
+  return const_iterator(const_cast<set_t&>(elementCounts));
+}
+
+void Formula::clear(){
+  elementCounts.clear();
+  numElements = 0;
+}
+
+/**************** Iterator structure ********************/
+
+template <class result_type>
+Formula::_iterator<result_type>::_iterator(set_t &_set) :
+    set(&_set)
+{
+  pos=set->size();
+}
+
+template <class result_type>
+Formula::_iterator<result_type>::_iterator(set_t &_set,size_t _pos) :
+  set(&_set),pos(_pos)
+{
+  ASSERT(pos<=set->size(),"invalid position in iterator construction");
+  while(pos<set->size() && (*set)[pos]==0) ++pos;
+}
+
+template <class result_type>
+Formula::_iterator<result_type>::_iterator(const _iterator &rhs) :
+  set(rhs.set),pos(rhs.pos)
+{}
+
+template <class result_type>
+Formula::_iterator<result_type>::~_iterator(){}
+
+template <class result_type>
+Formula::_iterator<result_type>&
+Formula::_iterator<result_type>::operator=(const _iterator<result_type> &rhs){
+  set=rhs.set;
+  pos=rhs.pos;
+  return *this;
+}
+
+template <class result_type>
+bool
+Formula::_iterator<result_type>::operator==(const _iterator<result_type> &rhs){
+  return set==rhs.set && pos==rhs.pos;
+}
+
+template <class result_type>
+bool
+Formula::_iterator<result_type>::operator!=(const _iterator<result_type> &rhs){
+  return !operator==(rhs);
+}
+
+template <class result_type>
+Formula::_iterator<result_type>
+Formula::_iterator<result_type>::operator++(){
+  ASSERT(pos!=set->size(),"Incrementing Formula::iterator beyond end");
+  pos++;
+  while(pos<set->size() && (*set)[pos]==0) ++pos;
+  return *this;
+}
+
+template <class result_type>
+Formula::_iterator<result_type>
+Formula::_iterator<result_type>::operator++(int){
+  Formula::_iterator<result_type> retval = *this;
+  ++(*this);
+  return retval;
+}
+
+template <class result_type>
+Formula::_iterator<result_type>
+Formula::_iterator<result_type>::operator--(){
+  ASSERT(pos!=0,"Decrementing Formula::iterator beyond begin");
+  pos--;
+  while(pos>0 && (*set)[pos]==0) --pos;
+  return *this;
+}
+
+template <class result_type>
+Formula::_iterator<result_type>
+Formula::_iterator<result_type>::operator--(int){
+  Formula::_iterator<result_type> retval = *this;
+  --(*this);
+  return retval;
+}
+
+template <class result_type>
+result_type
+Formula::_iterator<result_type>::operator*(){
+  const element *element = World::getInstance().getPeriode()->FindElement(pos+1);
+  ASSERT(element,"Element with position of iterator not found");
+  return make_pair(element,(*set)[pos]);
+}
+
+template <class result_type>
+result_type*
+Formula::_iterator<result_type>::operator->(){
+  // no one can keep this value around, so a static is ok to avoid temporaries
+  static value_type value=make_pair(reinterpret_cast<element*>(0),0); // no default constructor for std::pair
+  const element *element = World::getInstance().getPeriode()->FindElement(pos+1);
+  ASSERT(element,"Element with position of iterator not found");
+  value = make_pair(element,(*set)[pos]);
+  return &value;
+}
+
+// explicit instantiation of all iterator template methods
+// this is quite ugly, but there is no better way unless we expose iterator implementation
+
+// instantiate Formula::iterator
+template Formula::iterator::_iterator(set_t&);
+template Formula::iterator::_iterator(set_t&,size_t);
+template Formula::iterator::_iterator(const Formula::iterator&);
+template Formula::iterator::~_iterator();
+template Formula::iterator &Formula::iterator::operator=(const Formula::iterator&);
+template bool Formula::iterator::operator==(const Formula::iterator&);
+template bool Formula::iterator::operator!=(const Formula::iterator&);
+template Formula::iterator Formula::iterator::operator++();
+template Formula::iterator Formula::iterator::operator++(int);
+template Formula::iterator Formula::iterator::operator--();
+template Formula::iterator Formula::iterator::operator--(int);
+template Formula::value_type Formula::iterator::operator*();
+template Formula::value_type *Formula::iterator::operator->();
+
+// instantiate Formula::const_iterator
+template Formula::const_iterator::_iterator(set_t&);
+template Formula::const_iterator::_iterator(set_t&,size_t);
+template Formula::const_iterator::_iterator(const Formula::const_iterator&);
+template Formula::const_iterator::~_iterator();
+template Formula::const_iterator &Formula::const_iterator::operator=(const Formula::const_iterator&);
+template bool Formula::const_iterator::operator==(const Formula::const_iterator&);
+template bool Formula::const_iterator::operator!=(const Formula::const_iterator&);
+template Formula::const_iterator Formula::const_iterator::operator++();
+template Formula::Formula::const_iterator Formula::const_iterator::operator++(int);
+template Formula::Formula::const_iterator Formula::const_iterator::operator--();
+template Formula::Formula::const_iterator Formula::const_iterator::operator--(int);
+template const Formula::value_type Formula::const_iterator::operator*();
+template const Formula::value_type *Formula::const_iterator::operator->();
+
+/********************** I/O of Formulas ************************************************/
+
+std::ostream &operator<<(std::ostream &ost,const Formula &formula){
+  ost << formula.toString();
+  return ost;
+}
Index: src/Formula.hpp
===================================================================
--- src/Formula.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Formula.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,117 @@
+/*
+ * Formula.hpp
+ *
+ *  Created on: Jul 21, 2010
+ *      Author: crueger
+ */
+
+#ifndef FORMULA_HPP_
+#define FORMULA_HPP_
+
+#include <vector>
+#include <iosfwd>
+#include <iterator>
+
+#include "Exceptions/ParseError.hpp"
+
+#include "types.hpp"
+#include "Helpers/helpers.hpp"
+
+class element;
+
+class Formula
+{
+public:
+  typedef const element*                                key_type;
+  typedef unsigned int                                  mapped_type;
+  typedef std::pair<key_type, mapped_type>              value_type;
+  typedef std::vector<unsigned int>                     set_t;
+
+  template <class result_type>
+  class _iterator : public std::iterator <std::bidirectional_iterator_tag,
+                                         result_type>
+  {
+  public:
+    _iterator(set_t&);
+    _iterator(set_t&,size_t);
+    _iterator(const _iterator &rhs);
+    ~_iterator();
+    _iterator   &operator=(const _iterator &);
+    bool         operator==(const _iterator&);
+    bool         operator!=(const _iterator&);
+    _iterator    operator++();
+    _iterator    operator++(int);
+    _iterator    operator--();
+    _iterator    operator--(int);
+    result_type  operator*();
+    result_type *operator->();
+  private:
+    set_t *set;
+    size_t pos; // cannot use an iterator, because we need a position to access the element
+  };
+
+  typedef _iterator<value_type>                 iterator;
+  typedef _iterator<const value_type>           const_iterator;
+
+  Formula();
+  Formula(const std::string&);
+  Formula(const Formula&);
+  virtual ~Formula();
+
+  Formula &operator=(const Formula&);
+
+  std::string toString() const;
+  void fromString(const std::string&) throw(ParseError);
+  bool checkOut(std::ostream*) const;
+
+  unsigned int getElementCount() const;
+  bool hasElement(key_type)             const;
+  bool hasElement(atomicNumber_t)       const;
+  bool hasElement(const std::string&)   const;
+
+  void operator+=(key_type);
+  void operator+=(atomicNumber_t);
+  void operator+=(const std::string&);
+
+  void operator-=(key_type);
+  void operator-=(atomicNumber_t);
+  void operator-=(const std::string&);
+
+  void addElements(key_type,unsigned int);
+  void addElements(atomicNumber_t,unsigned int);
+  void addElements(const std::string&,unsigned int);
+
+  void addFormula(const Formula&,unsigned int);
+
+  enumeration<key_type> enumerateElements() const;
+
+  // only const versions, because someone might try to increment a previously
+  // not set element
+  const unsigned int operator[](key_type) const;
+  const unsigned int operator[](atomicNumber_t) const;
+  const unsigned int operator[](std::string)    const;
+
+  bool operator==(const Formula&) const;
+  bool operator!=(const Formula&) const;
+
+  iterator       begin();
+  const_iterator begin() const;
+  iterator       end();
+  const_iterator end()   const;
+
+  void clear();
+
+private:
+  void parseFromString(std::string::const_iterator&,std::string::const_iterator&,char) throw(ParseError);
+  int parseMaybeNumber(std::string::const_iterator &it,std::string::const_iterator &end) throw(ParseError);
+  // this contains all counts of elements in the formula
+  // the size of the actual structure might be used in comparisons
+  // so be sure not to keep any zero elements at the end
+  // e.g. {5;4;0;0;0;2;1} or {0;1;0;0;2} are ok, but {1;2;3;0;0;0} is bad
+  set_t elementCounts;
+  unsigned int numElements;
+};
+
+std::ostream &operator<<(std::ostream&,const Formula&);
+
+#endif /* FORMULA_HPP_ */
Index: src/Helpers/Assert.cpp
===================================================================
--- src/Helpers/Assert.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Helpers/Assert.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -46,55 +51,125 @@
 }
 
-using namespace Assert;
-
 #ifndef NDEBUG
 
-Action _my_assert::defaultAction = Ask;
-std::vector<Assert::hook_t> _my_assert::hooks;
-
-std::map<std::string,bool> _wrapper::ignores;
-const char* _wrapper::message_ptr = "source pointer did not point to object of desired type";
-const char* _wrapper::message_ref = "source reference did not contain object of desired type";
-
-
-bool _my_assert::check(const bool res,
-                       const char* condition,
-                       const char* message,
-                       const char* filename,
-                       const int line,
-                       bool& ignore)
+#ifdef __GNUC__
+#include <cstdlib>
+#include <execinfo.h>
+#include <cxxabi.h>
+#endif
+
+Assert::Action Assert::_my_assert::defaultAction = Ask;
+std::vector<Assert::hook_t> Assert::_my_assert::hooks;
+
+std::map<std::string,bool> Assert::_wrapper::ignores;
+const char* Assert::_wrapper::message_ptr = "source pointer did not point to object of desired type";
+const char* Assert::_wrapper::message_ref = "source reference did not contain object of desired type";
+
+bool Assert::_my_assert::check(const char* condition,
+                               const char* message,
+                               const char* filename,
+                               const int line,
+                               bool& ignore)
 {
-  if(!res){
-    cout << "Assertion \"" << condition << "\" failed in file " << filename << " at line " << line << endl;
-    cout << "Assertion Message: " << message << std::endl;
-    while(true){
-      char choice;
-      if(defaultAction==Ask) {
-        cout << "Please choose: (a)bort, (t)hrow execption, (i)gnore, al(w)ays ignore" << endl;
-        cin >> choice;
+  cout << "Assertion \"" << condition << "\" failed in file " << filename << " at line " << line << endl;
+  cout << "Assertion Message: " << message << std::endl;
+  while(true){
+    char choice;
+    if(defaultAction==Assert::Ask) {
+#ifdef __GNUC__
+      cout << "Please choose: (a)bort, (t)hrow execption, show (b)actrace, (i)gnore, al(w)ays ignore" << endl;
+#else
+      cout << "Please choose: (a)bort, (t)hrow execption, (i)gnore, al(w)ays ignore" << endl;
+#endif /* __GNUC__ */
+      cin >> choice;
+    }
+    else{
+      choice = ActionKeys[defaultAction];
+    }
+    switch(choice){
+      case 'a':
+        return true;
+        break;
+      case 't':
+        throw AssertionFailure(condition,filename,line,message);
+        break;
+#ifdef __GNUC__
+      case 'b':
+        Assert::_my_assert::backtrace(filename,line);
+       break;
+#endif /* __GNUC__ */
+      case 'w':
+        ignore = true;
+        // fallthrough
+      case 'i':
+        return false;
+        break;
+    }
+  }
+  return false;
+}
+
+#ifdef __GNUC__
+void Assert::_my_assert::backtrace(const char *file, int line){
+  const size_t max_depth = 100;
+  void* stack_addrs[max_depth];
+  size_t stack_depth;
+  char **stack_strings=0;
+  const char *func_name=0;
+  size_t sz = 64;
+
+  // get the backtrace
+  stack_depth   = ::backtrace(stack_addrs,max_depth);
+  stack_strings = backtrace_symbols(stack_addrs, stack_depth);
+  // used later for demangling
+  // reserved here, so we can free it unconditionally
+  char *dm_function = static_cast<char*>(malloc(sz));
+  if(!dm_function){
+    // malloc failed... we are out of luck
+    cout << "cannot provide stack trace due to exhausted memory" << endl;
+    return;
+  }
+
+  cout << "Backtrace from  " << file << "@" << line << ":" << endl;
+
+  // i=2 because we don't want this function, nor the assertion handler
+  for(unsigned int i=2;i<stack_depth-2;++i){
+    // find the mangled function name
+    char *begin = stack_strings[i];
+    // function name starts with a (
+    while(*begin && *begin!='(') ++begin;
+    char *end=begin;
+    while(*end && *end!='+') ++end;
+
+    // see if we found our function name
+    if(*begin && *end){
+      *begin++ = 0;
+      *end = 0;
+      // use the C++ demangler
+
+      int status;
+      char *func_ret = abi::__cxa_demangle(begin, dm_function, &sz, &status);
+      if(func_ret){
+        // abi might have realloced...
+        dm_function = func_ret;
+        func_name = dm_function;
       }
       else{
-        choice = ActionKeys[defaultAction];
+        // demangling failed... get the function name without demangling
+        func_name = begin;
       }
-      switch(choice){
-        case 'a':
-          return true;
-          break;
-        case 't':
-          throw AssertionFailure(condition,filename,line,message);
-          break;
-        case 'w':
-          ignore = true;
-          // fallthrough
-        case 'i':
-          return false;
-          break;
-      }
-    }
-  }
-  return false;
-}
-
-void _my_assert::doHooks(){
+    }
+    else{
+      // function name not found... get the whole line
+      func_name = stack_strings[i];
+    }
+    cout << func_name << endl;
+  }
+  free(dm_function);
+  free(stack_strings); // malloc()ed by backtrace_symbols
+}
+#endif /* __GNUC__ */
+
+void Assert::_my_assert::doHooks(){
   for(vector<hook_t>::reverse_iterator iter = hooks.rbegin(); iter!=hooks.rend(); ++iter ){
     (*iter)();
@@ -102,9 +177,9 @@
 }
 
-void _my_assert::addHook(hook_t hook){
+void Assert::_my_assert::addHook(hook_t hook){
   hooks.push_back(hook);
 }
 
-void _my_assert::removeHook(Assert::hook_t hook){
+void Assert::_my_assert::removeHook(Assert::hook_t hook){
   for(vector<hook_t>::iterator iter = hooks.begin(); iter!=hooks.end();){
     if((*iter)==hook){
@@ -117,11 +192,11 @@
 }
 
-void _my_assert::setDefault(Assert::Action action){
+void Assert::_my_assert::setDefault(Assert::Action action){
   defaultAction = action;
 }
-Assert::Action _my_assert::getDefault(){
+Assert::Action Assert::_my_assert::getDefault(){
   return defaultAction;
 }
-std::string _my_assert::printDefault(){
+std::string Assert::_my_assert::printDefault(){
   return ActionNames[defaultAction];
 }
Index: src/Helpers/Assert.hpp
===================================================================
--- src/Helpers/Assert.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Helpers/Assert.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,5 @@
 #include<sstream>
 #include<string>
-#include<iostream>
+#include<iosfwd>
 #include<vector>
 #include<map>
@@ -234,6 +234,6 @@
       static bool ignore = false;\
       if(!ignore){\
-        if(Assert::_my_assert::check((condition),STRINGIFY(condition),(message),\
-                                     __FILE__,__LINE__,ignore)){\
+        if(!(condition) && Assert::_my_assert::check(STRINGIFY(condition),(message),\
+                                                     __FILE__,__LINE__,ignore)){\
           Assert::_my_assert::doHooks();\
           DEBUG_BREAK;\
@@ -247,7 +247,7 @@
 		  static bool ignore = false; \
 		  if(!ignore){\
-			  if(Assert::_my_assert::check(false,"Exception caught",(message),__FILE__,__LINE__,ignore)){\
+			  if(Assert::_my_assert::check("Exception caught",(message),__FILE__,__LINE__,ignore)){\
 			    Assert::_my_assert::doHooks();\
-          DEBUG_BREAK;\
+                            DEBUG_BREAK;\
 			  }\
 		  }\
@@ -299,10 +299,12 @@
     class _my_assert{
     public:
-      static bool check(const bool res,
-                        const char* condition,
+      static bool check(const char* condition,
                         const char* message,
                         const char* filename,
                         const int line,
                         bool& ignore);
+#ifdef __GNUC__
+      static void backtrace(const char *file, int line);
+#endif /* __GNUC__ */
       static void addHook(Assert::hook_t hook);
       static void removeHook(Assert::hook_t hook);
@@ -332,6 +334,6 @@
 
       if(!ignore){
-        if(_my_assert::check(dynamic_cast<target>(src)==static_cast<target>(src),"type-safe typecast",
-                                       message_ptr,file,line,ignore)){
+        bool res = dynamic_cast<target>(src)==static_cast<target>(src);
+        if(!res && _my_assert::check("type-safe typecast",message_ptr,file,line,ignore)){
           _my_assert::doHooks();
           DEBUG_BREAK;
@@ -354,5 +356,5 @@
       catch(...){
         if(!ignore){
-          if(_my_assert::check(0,"type-safe typecast",message_ref,file,line,ignore)){
+          if(_my_assert::check("type-safe typecast",message_ref,file,line,ignore)){
             _my_assert::doHooks();
             DEBUG_BREAK;
Index: src/Helpers/Info.cpp
===================================================================
--- src/Helpers/Info.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Helpers/Info.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,48 @@
+/*
+ * Info.cpp
+ *
+ *  Created on: Nov 25, 2009
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Helpers/Info.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+
+int Info::verbosity = 0;
+
+/**
+ * Constructor. Do not use this function. Use getInstance() instead.
+ *
+ * \return Info instance
+ */
+Info::Info(const char *msg) :
+  FunctionName(msg)
+{
+  verbosity++;
+  DoLog(0) && (Log() << Verbose(0) << "Begin of " << FunctionName << endl);
+};
+
+/**
+ * Destructor. Better use purgeInstance().
+ */
+Info::~Info() {
+  DoLog(0) && (Log() << Verbose(0) << "End of " << FunctionName << endl);
+  verbosity--;
+}
+
+/**
+ * Sets the verbosity.
+ *
+ * \param verbosityLevel verbosity
+ */
+void Info::setVerbosity(int verbosityLevel) {
+  verbosity = verbosityLevel;
+}
Index: src/Helpers/Info.hpp
===================================================================
--- src/Helpers/Info.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Helpers/Info.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,30 @@
+/*
+ * Info.hpp
+ *
+ *  Created on: Nov 25, 2009
+ *      Author: heber
+ */
+
+#ifndef INFO_HPP_
+#define INFO_HPP_
+
+using namespace std;
+
+/*********************************************** includes ***********************************/
+
+/****************************************** forward declarations *****************************/
+
+/********************************************** definitions *********************************/
+
+class Info {
+public :
+  static int verbosity;
+  const char *FunctionName;
+
+  Info(const char *msg);
+  ~Info();
+  static void setVerbosity(int verbosityLevel);
+
+};
+
+#endif /* INFO_HPP_ */
